<?php
namespace Geral\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Geral\Util\TratamentoDeMensagens;
use Setforms2\Shared\Registry;

class Turnoserv extends Base\Turnoserv
{
    public static function exclui($cdfilial, $nrorg, $cdservfili, $cdturno) {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            $turnoserv = self::getObjectByWhere(
                'CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ? AND CDTURNO = ?',
                array($cdfilial, $nrorg, $cdservfili, $cdturno)
            );
            //
            $turnoserv->delete();
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function clonaTurnoserv(Servico $servicoModelo, Servico $servicoNovo, $conn){

            $codigomodelo = $servicoModelo->getCdservfili();
            $codigonovo = $servicoNovo->getCdservfili();
            $codigofilial = $servicoNovo->getCdfilial();
            $nrorg = Ambiente::getNrorg();
            $registrosTurnoserv = Turnoserv::getObjectsByWhere('
                NRORG = ? AND CDSERVFILI = ? AND CDFILIAL = ?',
                array($nrorg,$codigomodelo, $codigofilial ) );


            $operador = Ambiente::getCdOperador();
            $dtAtual = DateUtil::getDataAtual();
            if($registrosTurnoserv != false){
                /** @var $registronovo Turnoserv */
                foreach($registrosTurnoserv as $registromodelo){

                    $registronovo = clone $registromodelo;
                    $registronovo->setCdservfili($codigonovo);
                    $registronovo->setDtultatu($dtAtual);
                    $registronovo->setDtinclusao($dtAtual);
                    $registronovo->setCdoperinclusao($operador);
                    $registronovo->setCdoperultatu($operador);
                    $registronovo->persist();
                    $conn->flush();

                }
            }

    }
}