/* Sistemas Integrados TEKNISA
  Documentos Fiscais de Entrada

Nome: 5210_DFESTPS_NF_BAIXA_AF.SQL

Descrio:
Gera baixa dos produtos da AF.

@C:\Web_605\Sql\End_Conv\Oracle\5210_DFESTPS_NF_BAIXA_AF.SQL

P_CDFILIAL      - Cdigo da Filial de lanamento da nota fiscal.
P_NRLANCTONF    - Nmero de lanamento da nota fiscal.
P_NRSEQITPROD   - Sequencial do item da nota fiscal
P_IDSTATUS      - Status (I - Insero, A - Alterao, E - Excluso)
P_NEWCDPRODEMIS - Novo cdigo do produto de emisso
P_OLDCDPRODEMIS - Antigo cdigo do produto de emisso
P_NEWCDPRODUTO  - Novo cdigo do produto
P_OLDCDPRODUTO  - Antigo cdigo do produto
P_NEWCDMARCA    - Novo cdigo da marca do produto
P_OLDCDMARCA    - Antigo cdigo da marca do produto
P_NEWQTITEMPROD - Nova quantidade do produto
P_OLDQTITEMPROD - Antiga quantidade do produto
P_IDERRO        - Identificador de existncia de erros.

PARA DEBUGAR
-- raise_application_error(-20501, '' , True);

Criao:
20/09/2010 - Fabrcio Marcelo da Silva
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'NF_BAIXA_AF'  AND
           TYPE = 'P' 			     AND
	        U.UID = O.UID           AND
	        U.NAME = USER)

DROP PROCEDURE NF_BAIXA_AF
GO

CREATE PROCEDURE NF_BAIXA_AF @P_CDFILIAL        VARCHAR(04),
	                          @P_NRLANCTONF      VARCHAR(10),
	                          @P_NRSEQITPROD     VARCHAR(04),
	                          @P_IDSTATUS        VARCHAR(01),
	                          @P_NEWCDPRODEMIS   VARCHAR(20),
	                          @P_OLDCDPRODEMIS   VARCHAR(20),
	                          @P_NEWCDPRODUTO    VARCHAR(10),
	                          @P_OLDCDPRODUTO    VARCHAR(10),
	                          @P_NEWCDMARCA      VARCHAR(05),
                             @P_OLDCDMARCA      VARCHAR(05),
                             @P_NEWQTITEMPROD   NUMERIC(15,6),
                             @P_OLDQTITEMPROD   NUMERIC(15,6),
                             @P_IDERRO          VARCHAR(01) OUTPUT

AS
DECLARE @V_DTENTRSAID   DATETIME;
DECLARE @V_IDBAIXAAF    VARCHAR(1);
DECLARE @V_IDBAIXITMAF  VARCHAR(1);

DECLARE @V_TOTALITEM    NUMERIC(15,6);
DECLARE @V_BAIXATOTAL   NUMERIC(15,6);
DECLARE @V_BAIXAMANUAL  NUMERIC(15,6);
DECLARE @V_EMABERTO     NUMERIC(15,6);
DECLARE @V_BAIXAPARCIAL NUMERIC(15,6);
DECLARE @V_VRFATOCONV   NUMERIC(15,6);

DECLARE @V_IDENTRSAIDOP VARCHAR(1);
DECLARE @V_CDFILIEMIT   VARCHAR(4);
DECLARE @V_CDFILIRECE   VARCHAR(4);
DECLARE @V_NRSOLICMP    VARCHAR(10);

DECLARE @V_CDPRODCNV    VARCHAR(10);
DECLARE @V_VRFATUNEST   NUMERIC(10,4);

DECLARE @V_QTRESTNF     NUMERIC(15,5); --QUANTIDADE QUE IR AUMENTAR OU DIMINUIR NA BAIXA DAS AFS
DECLARE @V_QTBAIXAAF    NUMERIC(15,5); --QUANTIDADE NECESSRIA PARA COMPLETAR A BAIXA DO ITEM DA AF
DECLARE @V_QTUPITEMAF   NUMERIC(15,5); --QUANTIDADE QUE SER AUMENTADA OU DIMINUIDA DA BAIXA DO ITEM DA AF
DECLARE @V_QTNEWREST    NUMERIC(15,5); --QUANTIDADE DO PRODUTO NA NOTA FISCAL REDUZIDA DAS BAIXAS EFETUADAS.
DECLARE @V_QTJABAIXNF   NUMERIC(15,5); --QUANTIDADE DO PRODUTO J BAIXADA EM OUTRAS NOTAS FISCAIS

DECLARE @V_QTEFETENTRAF NUMERIC(15,5);

DECLARE @V_PRODUTO      VARCHAR(10);
DECLARE @V_CDPRODEMIS   VARCHAR(10);
DECLARE @V_MAXPRODUTO   VARCHAR(10);

DECLARE @V_QTITEMPROD   NUMERIC(15,5);

DECLARE @V_IDBLOQNFSAF  VARCHAR(01);

DECLARE @V_CDTIPOOPERO  VARCHAR(02);
DECLARE @V_CDFILIRECEO  VARCHAR(04);
DECLARE @V_CDARVPRODO   VARCHAR(20);

DECLARE @V_QTJABAIXADA  NUMERIC(15,5);

/*VARIVEIS DO CURSOR C_ITEMAUF*/
DECLARE @V_ITEMAUF_CDFILDEST    VARCHAR(4);
DECLARE @V_ITEMAUF_CDFILLANC    VARCHAR(4);
DECLARE @V_ITEMAUF_NRAUTOFORN   VARCHAR(10);
DECLARE @V_ITEMAUF_CDMARCA      VARCHAR(5);
DECLARE @V_ITEMAUF_CDPRODUTO    VARCHAR(10);
DECLARE @V_ITEMAUF_DTPROGENTAF  DATETIME;
DECLARE @V_ITEMAUF_QTPROGENTAF  NUMERIC(15,5);
DECLARE @V_ITEMAUF_QTEFETENTRAF NUMERIC(15,5);
DECLARE @V_ITEMAUF_IDBAIXITMAF  VARCHAR(1);
DECLARE @V_ITEMAUF_IDUTILITEM   VARCHAR(1);
DECLARE @V_ITEMAUF_CDFILIAL     VARCHAR(4);
DECLARE @V_ITEMAUF_NRLANCTONF   VARCHAR(10);
DECLARE @V_ITEMAUF_QTNFEFETAF   NUMERIC(15,5);

DECLARE @V_IDUTILDTPROC         VARCHAR(1);
DECLARE @V_IDBAIXITMFUTURA      VARCHAR(1);
DECLARE @V_DTPROCESSA           DATETIME;
DECLARE @V_CDMARCA              VARCHAR(5);

/*VARIVEIS DO CURSOR C_EXCLUI_RELACAF*/

DECLARE @V_EXCLUI_RELAC_CDFILDEST    VARCHAR(4);
DECLARE @V_EXCLUI_RELAC_CDFILLANC    VARCHAR(4);
DECLARE @V_EXCLUI_RELAC_NRAUTOFORN   VARCHAR(10);
DECLARE @V_EXCLUI_RELAC_CDMARCA      VARCHAR(5);
DECLARE @V_EXCLUI_RELAC_CDPRODUTO    VARCHAR(10);
DECLARE @V_EXCLUI_RELAC_DTPROGENTAF  DATETIME;
DECLARE @V_EXCLUI_RELAC_DTEFETENTAF  DATETIME;
DECLARE @V_EXCLUI_RELAC_QTPROGENTAF  NUMERIC(15,5);
DECLARE @V_EXCLUI_RELAC_QTEFETENTRAF NUMERIC(15,5);
DECLARE @V_EXCLUI_RELAC_IDBAIXITMAF  VARCHAR(1);
DECLARE @V_EXCLUI_RELAC_CDFILIAL     VARCHAR(4);
DECLARE @V_EXCLUI_RELAC_NRLANCTONF   VARCHAR(10);

BEGIN
   SET @P_IDERRO = 'N';      

   IF LEN(ISNULL(@P_OLDCDMARCA, @P_NEWCDMARCA)) <> 5 BEGIN
      SET @V_CDMARCA = 'T';
   END
   ELSE BEGIN
      SET @V_CDMARCA = ISNULL(@P_OLDCDMARCA, @P_NEWCDMARCA);
   END;

   SET @V_CDTIPOOPERO = NULL;
   SET @V_CDFILIRECEO = NULL;
   SET @V_CDARVPRODO  = NULL;

   SELECT @V_IDUTILDTPROC = ISNULL(MAX(IDUTILDTPROC), 'N')
   FROM PARAMGERAL;

   SELECT @V_CDTIPOOPERO = MAX(N.CDTIPOOPER),
          @V_CDFILIRECEO = MAX(N.CDFILIRECE),
          @V_CDARVPRODO = MAX(P.CDARVPROD)
     FROM NOTAFISCAL N, ITEMPRODUTO I, PRODUTO P
    WHERE N.CDFILIAL = @P_CDFILIAL
      AND N.NRLANCTONF = @P_NRLANCTONF
      AND I.CDFILIAL = N.CDFILIAL
      AND I.NRLANCTONF = N.NRLANCTONF
      AND I.NRSEQITPROD = @P_NRSEQITPROD
      AND P.CDPRODUTO = I.CDPRODUTO
      AND NOT EXISTS (SELECT CDFILIAL
                        FROM NFRELACAF R
                       WHERE R.CDFILIAL = I.CDFILIAL
                         AND R.NRLANCTONF = I.NRLANCTONF
                         AND R.CDPRODUTO = I.CDPRODUTO);


   IF (@V_CDTIPOOPERO = '01') AND NOT (@V_CDARVPRODO IS NULL) BEGIN
      /* Verificao de produtos oriundos da AF */
      IF (@P_IDSTATUS = 'I') BEGIN
         SET @V_IDBLOQNFSAF = NULL;
         SET @V_MAXPRODUTO  = NULL;

         SELECT @V_MAXPRODUTO = MAX(CDPRODUTO)
           FROM PARAMCMPPROD
          WHERE CDFILIAL = @V_CDFILIRECEO
            AND CHARINDEX(CDPRODUTO, @V_CDARVPRODO) = 1;

         IF (@V_MAXPRODUTO IS NOT NULL) BEGIN
            SELECT @V_IDBLOQNFSAF = MAX(IDBLOQNFSAF)
              FROM PARAMCMPPROD
             WHERE CDFILIAL  = @V_CDFILIRECEO
               AND CDPRODUTO = @V_MAXPRODUTO;
         END;

         /* Se o produto da nota fiscal necessitar ser oriundo de AF e no possuir relacionamento com a AF
            ser retornado erro */
         IF @V_IDBLOQNFSAF = 'S' BEGIN
            SET @P_IDERRO = 'S';
         END;
      END;
   END;

   IF @P_IDERRO <> 'S' BEGIN

      IF @P_IDSTATUS = 'I' BEGIN -- SE ESTIVER INSERINDO UM ITEM DA NF
         SELECT
            @V_CDPRODEMIS = MAX(CDPRODUTO)
         FROM
            PRODUTO
         WHERE
            CDARVPROD = @P_NEWCDPRODEMIS;

         IF @P_NEWCDPRODUTO <> @V_CDPRODEMIS BEGIN
            SET @V_PRODUTO = @V_CDPRODEMIS;
         END
         ELSE BEGIN
            SET @V_PRODUTO = @P_NEWCDPRODUTO;
         END;
      END;

      IF @P_IDSTATUS = 'A' BEGIN
         SELECT
            @V_CDPRODEMIS = MAX(CDPRODUTO)
         FROM
            PRODUTO
         WHERE
            CDARVPROD = @P_OLDCDPRODEMIS;

         IF @P_OLDCDPRODUTO <> @V_CDPRODEMIS BEGIN
            SET @V_PRODUTO = @V_CDPRODEMIS;
         END
         ELSE BEGIN
            SET @V_PRODUTO = @P_OLDCDPRODUTO;
         END;
         IF @V_PRODUTO IS NULL BEGIN
            SELECT
               @V_CDPRODEMIS = MAX(CDPRODUTO)  
            FROM
               PRODUTO
            WHERE
               CDARVPROD = @P_NEWCDPRODEMIS;

            IF @P_NEWCDPRODUTO <> @V_CDPRODEMIS BEGIN
               SET @V_PRODUTO = @V_CDPRODEMIS;
            END
            ELSE BEGIN
               SET @V_PRODUTO = @P_NEWCDPRODUTO;
            END;
         END;
      END;

      IF @P_IDSTATUS = 'E' BEGIN
         SELECT
            @V_CDPRODEMIS = MAX(CDPRODUTO)
         FROM
            PRODUTO
         WHERE
            CDARVPROD = @P_OLDCDPRODEMIS;

         IF @P_OLDCDPRODUTO <> @V_CDPRODEMIS BEGIN
            SET @V_PRODUTO = @V_CDPRODEMIS;
         END
         ELSE BEGIN
            SET @V_PRODUTO = @P_OLDCDPRODUTO;
         END;
      END;

      SELECT
        @V_DTENTRSAID = MAX(DTENTRSAID),
        @V_IDENTRSAIDOP = MAX(IDENTRSAIDOP),
        @V_CDFILIEMIT = MAX(CDFILIEMIT),
        @V_CDFILIRECE = MAX(CDFILIRECE)
      FROM NOTAFISCAL
      WHERE CDFILIAL = @P_CDFILIAL
        AND NRLANCTONF = @P_NRLANCTONF;

      IF @V_IDENTRSAIDOP = 'E' BEGIN
         IF @P_IDSTATUS = 'I' BEGIN   -- SE ESTIVER INSERINDO UM ITEM DA NF
            SET @V_QTRESTNF   = @P_NEWQTITEMPROD;
            SET @V_QTITEMPROD = @P_NEWQTITEMPROD;
         END;
         IF @P_IDSTATUS = 'A' BEGIN
            SET @V_QTRESTNF   = @P_NEWQTITEMPROD - @P_OLDQTITEMPROD;
            SET @V_QTITEMPROD = @P_NEWQTITEMPROD - @P_OLDQTITEMPROD;
         END;
         IF @P_IDSTATUS = 'E' BEGIN
            SET @V_QTRESTNF   = - @P_OLDQTITEMPROD;
            SET @V_QTITEMPROD = @P_OLDQTITEMPROD;
         END;

         IF @P_IDSTATUS = 'I' BEGIN  -- SE ESTIVER INSERINDO UM ITEM DA NF
            DECLARE C_ITEMAUF_INSERT CURSOR FOR
               SELECT
                  ITEMAUTF.CDFILDEST,
                  ITEMAUTF.CDFILLANC,
                  ITEMAUTF.NRAUTOFORN,
                  ITEMAUTF.CDMARCA,
                  ITEMAUTF.CDPRODUTO,
                  ITEMAUTF.DTPROGENTAF,
                  ITEMAUTF.QTPROGENTAF,
                  ISNULL(ITEMAUTF.QTEFETENTRAF, 0) AS QTEFETENTRAF,
                  ITEMAUTF.IDBAIXITMAF,
                  NFRELACAF.CDFILIAL,
                  NFRELACAF.NRLANCTONF
               FROM
                  ITEMAUTF,
                  NFRELACAF
               WHERE
                  NFRELACAF.CDFILIAL    = @P_CDFILIAL          AND
                  NFRELACAF.NRLANCTONF  = @P_NRLANCTONF        AND
                  NFRELACAF.CDFILDEST   = ITEMAUTF.CDFILDEST   AND
                  NFRELACAF.CDFILLANC   = ITEMAUTF.CDFILLANC   AND
                  NFRELACAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN  AND
                  NFRELACAF.CDMARCA     = ITEMAUTF.CDMARCA     AND
                  NFRELACAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO   AND
                  NFRELACAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF AND
                  ((NFRELACAF.CDMARCA   = @V_CDMARCA) OR (@V_CDMARCA = 'T')) AND
                  NFRELACAF.CDPRODUTO   = @V_PRODUTO
               ORDER BY
                  1, 2, 6, 3;
         END
         ELSE BEGIN
            DECLARE C_ITEMAUF CURSOR FOR
               SELECT
                  ITEMAUTF.CDFILDEST,
                  ITEMAUTF.CDFILLANC,
                  ITEMAUTF.NRAUTOFORN,
                  ITEMAUTF.CDMARCA,
                  ITEMAUTF.CDPRODUTO,
                  ITEMAUTF.DTPROGENTAF,
                  ITEMAUTF.QTPROGENTAF,
                  ISNULL(ITEMAUTF.QTEFETENTRAF, 0) AS QTEFETENTRAF,
                  ITEMAUTF.IDBAIXITMAF,
                  NFRELACAF.CDFILIAL,
                  NFRELACAF.NRLANCTONF,
                  NFRELACAF.QTNFEFETAF
               FROM
                  ITEMAUTF,
                  NFRELACAF
               WHERE
                  NFRELACAF.CDFILIAL    = @P_CDFILIAL          AND
                  NFRELACAF.NRLANCTONF  = @P_NRLANCTONF        AND
                  NFRELACAF.CDFILDEST   = ITEMAUTF.CDFILDEST   AND
                  NFRELACAF.CDFILLANC   = ITEMAUTF.CDFILLANC   AND
                  NFRELACAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN  AND
                  NFRELACAF.CDMARCA     = ITEMAUTF.CDMARCA     AND
                  NFRELACAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO   AND
                  NFRELACAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF AND
                  ((NFRELACAF.CDMARCA   = @V_CDMARCA) OR (@V_CDMARCA = 'T')) AND
                  NFRELACAF.CDPRODUTO   = @V_PRODUTO
               ORDER BY
                  1, 2, 6 DESC, 3 DESC;

         END;

         IF @P_IDSTATUS = 'I' BEGIN
            OPEN C_ITEMAUF_INSERT;
         END
         ELSE BEGIN
            OPEN C_ITEMAUF;
         END;

         IF @P_IDSTATUS = 'I' BEGIN
            FETCH NEXT FROM C_ITEMAUF_INSERT INTO @V_ITEMAUF_CDFILDEST, @V_ITEMAUF_CDFILLANC,
                                                @V_ITEMAUF_NRAUTOFORN,  @V_ITEMAUF_CDMARCA,
                                                @V_ITEMAUF_CDPRODUTO,   @V_ITEMAUF_DTPROGENTAF,
                                                @V_ITEMAUF_QTPROGENTAF, @V_ITEMAUF_QTEFETENTRAF,
                                                @V_ITEMAUF_IDBAIXITMAF, @V_ITEMAUF_CDFILIAL,
                                                @V_ITEMAUF_NRLANCTONF;
         END
         ELSE BEGIN
            FETCH NEXT FROM C_ITEMAUF INTO @V_ITEMAUF_CDFILDEST,   @V_ITEMAUF_CDFILLANC,
                                         @V_ITEMAUF_NRAUTOFORN,  @V_ITEMAUF_CDMARCA,
                                         @V_ITEMAUF_CDPRODUTO,   @V_ITEMAUF_DTPROGENTAF,
                                         @V_ITEMAUF_QTPROGENTAF, @V_ITEMAUF_QTEFETENTRAF,
                                         @V_ITEMAUF_IDBAIXITMAF, @V_ITEMAUF_CDFILIAL,
                                         @V_ITEMAUF_NRLANCTONF, @V_ITEMAUF_QTNFEFETAF;
         END;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF @P_IDSTATUS <> 'I' BEGIN
               -- Verifica quantidade j baixada em outras AFs do produto

               SET @V_QTJABAIXADA = 0;

               SELECT @V_QTJABAIXADA = ISNULL(SUM(IT.QTEFETENTRAF), 0)
                 FROM ITEMAUTF IT, NFRELACAF NF
                WHERE NF.CDFILIAL = @P_CDFILIAL
                  AND NF.NRLANCTONF = @P_NRLANCTONF
                  AND NF.CDFILDEST = IT.CDFILDEST
                  AND NF.CDFILLANC = IT.CDFILLANC
                  AND NF.NRAUTOFORN = IT.NRAUTOFORN
                  AND NF.CDMARCA = IT.CDMARCA
                  AND NF.CDPRODUTO = IT.CDPRODUTO
                  AND NF.DTPROGENTAF = IT.DTPROGENTAF
                  AND ((NF.CDMARCA = @V_CDMARCA) OR (@V_CDMARCA = 'T'))
                  AND NF.CDPRODUTO = @P_NEWCDPRODUTO
                  AND (NF.CDFILLANC+NF.CDFILDEST+NF.NRAUTOFORN) <> @V_ITEMAUF_CDFILLANC+@V_ITEMAUF_CDFILDEST+@V_ITEMAUF_NRAUTOFORN;

               SET @V_QTNEWREST = @P_NEWQTITEMPROD - @V_QTJABAIXADA;

               -- Verifica quantidade j baixada em outras notas fiscais

               SET @V_QTJABAIXNF = 0;

               SELECT @V_QTJABAIXNF = ISNULL(SUM(IT.QTITEMPROD), 0)
                 FROM ITEMPRODUTO IT, NFRELACAF NF
                WHERE NF.CDFILLANC = @V_ITEMAUF_CDFILLANC
                  AND NF.CDFILDEST = @V_ITEMAUF_CDFILDEST
                  AND NF.NRAUTOFORN = @V_ITEMAUF_NRAUTOFORN
                  AND NF.CDPRODUTO = @P_NEWCDPRODUTO

                  AND IT.CDFILIAL = NF.CDFILIAL
                  AND IT.NRLANCTONF = NF.NRLANCTONF
                  AND IT.CDPRODUTO = NF.CDPRODUTO
                  AND (NF.CDFILIAL+NF.NRLANCTONF) <> @P_CDFILIAL+@P_NRLANCTONF;

               SET @V_QTNEWREST = @V_QTNEWREST + @V_QTJABAIXNF;

            END;

            SET @V_QTBAIXAAF = @V_ITEMAUF_QTPROGENTAF - @V_ITEMAUF_QTEFETENTRAF;  -- QUNATIDADE NECESSRIA PARA COMPLETAR O CAMPO QTEFETENTRAF

            IF (@V_QTRESTNF <> 0) BEGIN --SE O ITEM NO ESTA BAIXADO TOTALMENTE E HOVER QUANTIDADE A SER ATUALIZADA NA BAIXA DO...

               SET @V_QTUPITEMAF = @V_QTRESTNF;

               IF @P_IDSTATUS = 'A' BEGIN
                  IF @V_QTRESTNF > 0 BEGIN                        /* ################################################ */
                     IF @V_QTRESTNF > @V_QTBAIXAAF BEGIN           /* AJUSTE DA QUANTIDATE A SER SOMADA NA BAIXA DA AF */
                        SET @V_QTUPITEMAF = @V_QTBAIXAAF;            /* ################################################ */
                     END;
                  END
                  ELSE BEGIN
                     IF ((@V_QTNEWREST < @V_ITEMAUF_QTEFETENTRAF) AND
                         (@V_ITEMAUF_QTEFETENTRAF <> 0))         BEGIN

                        IF ABS(@V_ITEMAUF_QTEFETENTRAF-@V_QTNEWREST) >= @V_ITEMAUF_QTEFETENTRAF BEGIN
                           SET @V_QTUPITEMAF = @V_ITEMAUF_QTEFETENTRAF * (-1);
                        END
                        ELSE BEGIN                                             /* ################################################ */
                           SET @V_QTUPITEMAF = (@V_ITEMAUF_QTEFETENTRAF-@V_QTNEWREST) * (-1);  /* AJUSTE DA QUANTIDATE A SER SOMADA NA BAIXA DA AF */
                        END;                                                  /* ################################################ */
                     END
                     ELSE BEGIN
                        SET @V_QTUPITEMAF = 0;
                     END;
                  END;

                  SET @V_QTNEWREST = @V_QTNEWREST - @V_QTUPITEMAF;
               END
               ELSE BEGIN
                  IF @P_IDSTATUS = 'I' BEGIN
                     IF @V_QTRESTNF > 0 BEGIN                        /* ################################################ */
                        IF @V_QTRESTNF > @V_QTBAIXAAF BEGIN           /* AJUSTE DA QUANTIDATE A SER SOMADA NA BAIXA DA AF */
                           SET @V_QTUPITEMAF = @V_QTBAIXAAF;            /* ################################################ */
                        END;
                     END
                     ELSE BEGIN                                       /* ################################################ */
                        IF ABS(@V_QTRESTNF) >= @V_ITEMAUF_QTEFETENTRAF BEGIN   /* AJUSTE DA QUANTIDATE A SER SOMADA NA BAIXA DA AF */
                           SET @V_QTUPITEMAF = (@V_ITEMAUF_QTEFETENTRAF - @V_QTJABAIXNF) * (-1);  /* ################################################ */
                        END;
                     END;
                  END
                  ELSE BEGIN
                     SET @V_QTUPITEMAF = ISNULL(- @V_ITEMAUF_QTNFEFETAF, 0);
                  END;
               END;

               SET @V_QTRESTNF = @V_QTRESTNF - @V_QTUPITEMAF;

               IF ROUND(@V_ITEMAUF_QTPROGENTAF, 5) <= ROUND((@V_ITEMAUF_QTEFETENTRAF + @V_QTUPITEMAF), 5) BEGIN /* ################################################ */
                  SET @V_IDBAIXITMAF = '2';                                                   /* AJUSTE DO IDENTIFICADOR DE BAIXA DO ITEM DA AF   */
               END
               ELSE BEGIN
                  SET @V_IDBAIXITMAF = '1';
               END;

               IF @V_ITEMAUF_QTEFETENTRAF + @V_QTUPITEMAF = 0 BEGIN
                  SET @V_IDBAIXITMAF = NULL;
                  SET @V_DTENTRSAID  = NULL;
               END;

               SET @V_QTEFETENTRAF = @V_ITEMAUF_QTEFETENTRAF + @V_QTUPITEMAF;
               IF @V_QTEFETENTRAF = 0 BEGIN
                  SET @V_QTEFETENTRAF = NULL;
               END;

               IF @V_DTENTRSAID IS NOT NULL BEGIN
                  SELECT @V_DTPROCESSA = CASE @V_IDUTILDTPROC
                                            WHEN 'S' THEN ISNULL(MAX(PF.DTPROCESSA), CONVERT(DATETIME, GETDATE(),103))
                                            ELSE CONVERT(DATETIME, GETDATE(),103)
                                         END
                    FROM PARAMFILIAL PF
                   WHERE PF.CDFILIAL = @V_ITEMAUF_CDFILDEST;
                  IF @V_DTENTRSAID > @V_DTPROCESSA BEGIN
                     SET @V_IDBAIXITMFUTURA = 'S';
                  END
                  ELSE BEGIN
                     SET @V_IDBAIXITMFUTURA = 'N';
                  END;
               END
               ELSE BEGIN
                  SET @V_IDBAIXITMFUTURA = 'X';
               END;

               IF (@P_IDSTATUS = 'I') BEGIN
                  UPDATE NFRELACAF
                     SET QTNFEFETAF  = (ISNULL(QTNFEFETAF, 0) + (ISNULL(@V_QTUPITEMAF, 0)))
                   WHERE CDFILDEST   = @V_ITEMAUF_CDFILDEST
                     AND CDFILLANC   = @V_ITEMAUF_CDFILLANC
                     AND NRAUTOFORN  = @V_ITEMAUF_NRAUTOFORN
                     AND CDPRODUTO   = @V_ITEMAUF_CDPRODUTO
                     AND CDMARCA     = @V_ITEMAUF_CDMARCA
                     AND DTPROGENTAF = @V_ITEMAUF_DTPROGENTAF
                     AND CDFILIAL    = @P_CDFILIAL
                     AND NRLANCTONF  = @P_NRLANCTONF;
               END;

               IF (@P_IDSTATUS = 'A') BEGIN
                  UPDATE NFRELACAF
                     SET QTNFEFETAF  = (ISNULL(QTNFEFETAF, 0) + (ISNULL(@V_QTUPITEMAF, 0)))
                   WHERE CDFILDEST   = @V_ITEMAUF_CDFILDEST
                     AND CDFILLANC   = @V_ITEMAUF_CDFILLANC
                     AND NRAUTOFORN  = @V_ITEMAUF_NRAUTOFORN
                     AND CDPRODUTO   = @V_ITEMAUF_CDPRODUTO
                     AND CDMARCA     = @V_ITEMAUF_CDMARCA
                     AND DTPROGENTAF = @V_ITEMAUF_DTPROGENTAF
                     AND CDFILIAL    = @P_CDFILIAL
                     AND NRLANCTONF  = @P_NRLANCTONF;
               END;

               UPDATE ITEMAUTF
               SET  IDBAIXITMAF  = @V_IDBAIXITMAF,
                    QTEFETENTRAF = @V_QTEFETENTRAF,
                    DTEFETENTAF  = @V_DTENTRSAID,
                    CDOPERBAIXA  = NULL,
                    DTBAIXITMAF  = NULL,
                    IDBAIXITMFUTURA = @V_IDBAIXITMFUTURA
               WHERE
                @V_ITEMAUF_CDFILDEST   = ITEMAUTF.CDFILDEST AND
                @V_ITEMAUF_CDFILLANC   = ITEMAUTF.CDFILLANC AND
                @V_ITEMAUF_NRAUTOFORN  = ITEMAUTF.NRAUTOFORN AND
                @V_ITEMAUF_CDPRODUTO   = ITEMAUTF.CDPRODUTO AND
                @V_ITEMAUF_CDMARCA     = ITEMAUTF.CDMARCA AND
                @V_ITEMAUF_DTPROGENTAF = ITEMAUTF.DTPROGENTAF;

                IF @V_IDBAIXITMAF IS NULL BEGIN
                   IF @P_IDSTATUS = 'E' BEGIN

                      DELETE FROM NFRELACAF
                      WHERE
                       @V_ITEMAUF_CDFILDEST   = CDFILDEST AND
                       @V_ITEMAUF_CDFILLANC   = CDFILLANC AND
                       @V_ITEMAUF_NRAUTOFORN  = NRAUTOFORN AND
                       @V_ITEMAUF_CDPRODUTO   = CDPRODUTO AND
                       @V_ITEMAUF_CDMARCA     = CDMARCA AND
                       @V_ITEMAUF_DTPROGENTAF = DTPROGENTAF AND
                       @V_ITEMAUF_CDFILIAL    = CDFILIAL AND
                       @V_ITEMAUF_NRLANCTONF  = NRLANCTONF;
                   END;
                END;
            END;

            SET @V_TOTALITEM    = 0;
            SET @V_BAIXATOTAL   = 0;
            SET @V_BAIXAMANUAL  = 0;
            SET @V_EMABERTO     = 0;
            SET @V_BAIXAPARCIAL = 0;


            SELECT @V_TOTALITEM = COUNT(*)  -- BUSCA O TOTAL DE ITENS DA AF
            FROM ITEMAUTF
            WHERE
               @V_ITEMAUF_CDFILDEST  = ITEMAUTF.CDFILDEST AND
               @V_ITEMAUF_CDFILLANC  = ITEMAUTF.CDFILLANC AND
               @V_ITEMAUF_NRAUTOFORN = ITEMAUTF.NRAUTOFORN;

            SELECT @V_EMABERTO = COUNT(*)    -- BUSCA O TOTAL DE ITENS DA AF EM ABERTO
            FROM ITEMAUTF
            WHERE
               @V_ITEMAUF_CDFILDEST  = ITEMAUTF.CDFILDEST AND
               @V_ITEMAUF_CDFILLANC  = ITEMAUTF.CDFILLANC AND
               @V_ITEMAUF_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
               ITEMAUTF.IDBAIXITMAF IS NULL;

            SELECT @V_BAIXAPARCIAL = COUNT(*)   -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA PARCIAL
            FROM ITEMAUTF
            WHERE
               @V_ITEMAUF_CDFILDEST  = ITEMAUTF.CDFILDEST AND
               @V_ITEMAUF_CDFILLANC  = ITEMAUTF.CDFILLANC AND
               @V_ITEMAUF_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
               ITEMAUTF.IDBAIXITMAF = '1';

            SELECT @V_BAIXATOTAL = COUNT(*)  -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA TOTAL
            FROM ITEMAUTF
            WHERE
               @V_ITEMAUF_CDFILDEST  = ITEMAUTF.CDFILDEST AND
               @V_ITEMAUF_CDFILLANC  = ITEMAUTF.CDFILLANC AND
               @V_ITEMAUF_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
               ITEMAUTF.IDBAIXITMAF = '2';

            SELECT @V_BAIXAMANUAL = COUNT(*)   -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA MANUAL
            FROM ITEMAUTF
            WHERE
               @V_ITEMAUF_CDFILDEST  = ITEMAUTF.CDFILDEST AND
               @V_ITEMAUF_CDFILLANC  = ITEMAUTF.CDFILLANC AND
               @V_ITEMAUF_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
               ITEMAUTF.IDBAIXITMAF = '3';

            IF @V_TOTALITEM = @V_EMABERTO BEGIN
               SET @V_IDBAIXAAF = NULL;  -- AF EM ABERTO
            END;
            IF @V_TOTALITEM = @V_BAIXATOTAL BEGIN
               SET @V_IDBAIXAAF = '2';   -- AF COM BAIXA TOTAL
            END;
            IF @V_BAIXAPARCIAL > 0 BEGIN
               SET @V_IDBAIXAAF = '1';   -- AF COM BAIXA PARCIAL
            END;
            IF (@V_TOTALITEM = @V_BAIXATOTAL + @V_BAIXAMANUAL) AND
               (@V_BAIXAMANUAL > 0) BEGIN
               SET @V_IDBAIXAAF = '3';   -- AF COM BAIXA MANUAL
            END;
            IF (@V_TOTALITEM = @V_BAIXATOTAL + @V_BAIXAMANUAL + @V_EMABERTO) AND
               (@V_EMABERTO > 0) AND (@V_EMABERTO < @V_TOTALITEM) BEGIN
               SET @V_IDBAIXAAF = '1';   -- AF COM BAIXA PARCIAL
            END;

            UPDATE AUTOFORNE  -- ALTERA O ID DE BAIXA DA AF
            SET IDBAIXAAF = @V_IDBAIXAAF
            WHERE
               @V_ITEMAUF_CDFILDEST  = AUTOFORNE.CDFILDEST AND
               @V_ITEMAUF_CDFILLANC  = AUTOFORNE.CDFILLANC AND
               @V_ITEMAUF_NRAUTOFORN = AUTOFORNE.NRAUTOFORN;

            IF @P_IDSTATUS = 'I' BEGIN
               FETCH NEXT FROM C_ITEMAUF_INSERT INTO @V_ITEMAUF_CDFILDEST,   @V_ITEMAUF_CDFILLANC,
                                                   @V_ITEMAUF_NRAUTOFORN,  @V_ITEMAUF_CDMARCA,
                                                   @V_ITEMAUF_CDPRODUTO,   @V_ITEMAUF_DTPROGENTAF,
                                                   @V_ITEMAUF_QTPROGENTAF, @V_ITEMAUF_QTEFETENTRAF,
                                                   @V_ITEMAUF_IDBAIXITMAF, @V_ITEMAUF_CDFILIAL,
                                                   @V_ITEMAUF_NRLANCTONF;
            END
            ELSE BEGIN
               FETCH NEXT FROM C_ITEMAUF INTO @V_ITEMAUF_CDFILDEST,   @V_ITEMAUF_CDFILLANC,
                                            @V_ITEMAUF_NRAUTOFORN,  @V_ITEMAUF_CDMARCA,
                                            @V_ITEMAUF_CDPRODUTO,   @V_ITEMAUF_DTPROGENTAF,
                                            @V_ITEMAUF_QTPROGENTAF, @V_ITEMAUF_QTEFETENTRAF,
                                            @V_ITEMAUF_IDBAIXITMAF, @V_ITEMAUF_CDFILIAL,
                                            @V_ITEMAUF_NRLANCTONF, @V_ITEMAUF_QTNFEFETAF;
            END;
         END;

         IF @P_IDSTATUS = 'I' BEGIN
            CLOSE C_ITEMAUF_INSERT;
            DEALLOCATE C_ITEMAUF_INSERT;
         END
         ELSE BEGIN
            CLOSE C_ITEMAUF;
            DEALLOCATE C_ITEMAUF;
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'NF_BAIXA_AF','6.05.XXX';
GO
