CREATE OR REPLACE PROCEDURE DUPLICA_SUBGRUPO_MENUGRID
(
P_CDFILIAL IN VARCHAR2,
P_CDCIA IN VARCHAR2,
P_CDMANCIA IN VARCHAR2,
P_NRSERVICOCIAFILI IN NUMBER,
P_CDCLASSE IN VARCHAR2,
P_CDSUBGRU IN VARCHAR2,
P_NRSEQSUBGRUSEMAM IN NUMBER,
P_CDOPERADOR IN VARCHAR2,
P_NRORG IN NUMBER
)
AS
V_SEQ VARCHAR2(20);
V_NRSEQSUBGRUSEMAM NUMBER;
V_NRORDSUBGRUSEMAM NUMBER;
BEGIN
   NOVO_CODIGO('AUXSUBGRUSEMAM', V_SEQ);
   V_NRSEQSUBGRUSEMAM := TO_NUMBER(V_SEQ);
   
   SELECT MAX(NRORDSUBGRUSEMAM)
     INTO V_NRORDSUBGRUSEMAM
     FROM SUBGRUSEMAM
    WHERE CDFILIAL = P_CDFILIAL
      AND CDCIA = P_CDCIA
      AND CDMANCIA = P_CDMANCIA
      AND NRSERVICOCIAFILI = P_NRSERVICOCIAFILI
      AND CDCLASSE = P_CDCLASSE;
   V_NRORDSUBGRUSEMAM := NVL(V_NRORDSUBGRUSEMAM, 1) + 1;
   
   INSERT INTO AUXSUBGRUSEMAM
   (CDFILIAL, CDCIA, CDMANCIA, NRSERVICOCIAFILI,
    CDCLASSE, CDSUBGRU, NRSEQSUBGRUSEMAM,
    IDPROPSUBSEMAM, QTPROPSUBSEMAM, DTINIVGSUMA, DTFIMVGSUMA, NRORDSUBGRUSEMAM, NRSEQSUBGRUORI,
    NRORG, NRORGINCLUSAO, NRORGULTATU,
    CDOPERINCLUSAO, CDOPERULTATU,
    DTULTATU, DTINCLUSAO, IDATIVO)
   SELECT CDFILIAL, CDCIA, CDMANCIA, NRSERVICOCIAFILI,
    CDCLASSE, CDSUBGRU, V_NRSEQSUBGRUSEMAM,
    IDPROPSUBSEMAM, QTPROPSUBSEMAM, NULL, NULL, V_NRORDSUBGRUSEMAM, P_NRSEQSUBGRUSEMAM,
    P_NRORG, P_NRORG, P_NRORG,
    P_CDOPERADOR, P_CDOPERADOR,
    SYSDATE, SYSDATE, 'S'
    FROM SUBGRUSEMAM
   WHERE CDFILIAL = P_CDFILIAL
     AND CDCIA = P_CDCIA
     AND CDMANCIA = P_CDMANCIA
     AND NRSERVICOCIAFILI = P_NRSERVICOCIAFILI
     AND CDCLASSE = P_CDCLASSE
     AND CDSUBGRU = P_CDSUBGRU
     AND NRSEQSUBGRUSEMAM = P_NRSEQSUBGRUSEMAM;
     
   INSERT INTO AUXPROPSUBGRUSE
   (CDFILIAL, CDCIA, CDMANCIA,
    NRSERVICOCIAFILI, CDCLASSE, 
    CDSUBGRU, NRSEQSUBGRUSEMAM, 
    QTPAXDE, QTPAXATE, QTSUBGRUPO,
    NRORG, NRORGINCLUSAO, NRORGULTATU,
    CDOPERINCLUSAO, CDOPERULTATU,
    DTULTATU, DTINCLUSAO, IDATIVO)
   SELECT CDFILIAL, CDCIA, CDMANCIA,
          NRSERVICOCIAFILI, CDCLASSE,
          CDSUBGRU, V_NRSEQSUBGRUSEMAM,
          QTPAXDE, QTPAXATE, QTSUBGRUPO,
          P_NRORG, P_NRORG, P_NRORG,
          P_CDOPERADOR, P_CDOPERADOR,
          SYSDATE, SYSDATE, 'S'
    FROM PROPSUBGRUSE
   WHERE CDFILIAL = P_CDFILIAL
     AND CDCIA = P_CDCIA
     AND CDMANCIA = P_CDMANCIA
     AND NRSERVICOCIAFILI = P_NRSERVICOCIAFILI
     AND CDCLASSE = P_CDCLASSE
     AND CDSUBGRU = P_CDSUBGRU
     AND NRSEQSUBGRUSEMAM = P_NRSEQSUBGRUSEMAM;
   
   INSERT INTO AUXPROCIASUBSEMAM
   (CDFILIAL, CDCIA, CDMANCIA,
    NRSERVICOCIAFILI, CDCLASSE, 
    CDSUBGRU, NRSEQSUBGRUSEMAM,
    CDPRODUTO, QTPRODUTOCIA, NRORDEM,
    NRORG, NRORGINCLUSAO, NRORGULTATU,
    CDOPERINCLUSAO, CDOPERULTATU,
    DTULTATU, DTINCLUSAO, IDATIVO)
   SELECT CDFILIAL, CDCIA, CDMANCIA,
    NRSERVICOCIAFILI, CDCLASSE, 
    CDSUBGRU, V_NRSEQSUBGRUSEMAM,
    CDPRODUTO, QTPRODUTOCIA, NRORDEM,
    P_NRORG, P_NRORG, P_NRORG,
    P_CDOPERADOR, P_CDOPERADOR,
    SYSDATE, SYSDATE, 'S'
     FROM PROCIASUBSEMAM
    WHERE CDFILIAL = P_CDFILIAL
     AND CDCIA = P_CDCIA
     AND CDMANCIA = P_CDMANCIA
     AND NRSERVICOCIAFILI = P_NRSERVICOCIAFILI
     AND CDCLASSE = P_CDCLASSE
     AND CDSUBGRU = P_CDSUBGRU
     AND NRSEQSUBGRUSEMAM = P_NRSEQSUBGRUSEMAM;
     
   INSERT INTO AUXCICLOSUBGRUSEMAM
   (CDFILIAL, CDCIA, CDMANCIA, NRSERVICOCIAFILI,
    CDCLASSE, CDSUBGRU, NRSEQSUBGRUSEMAM,
    CDCICLO, NRITAIRVISION, FGFOTOSUBSEMAM, FGFOTOSUBSEMAMT,
    DTEFETSUMA, DTREVISUMA, DSSUBGRUPOIMP,
    NRORG, NRORGINCLUSAO, NRORGULTATU,
    CDOPERINCLUSAO, CDOPERULTATU,
    DTULTATU, DTINCLUSAO, IDATIVO)    
   SELECT CDFILIAL, CDCIA, CDMANCIA, NRSERVICOCIAFILI,
    CDCLASSE, CDSUBGRU, V_NRSEQSUBGRUSEMAM,
    CDCICLO, NRITAIRVISION, FGFOTOSUBSEMAM, FGFOTOSUBSEMAMT,
    DTEFETSUMA, DTREVISUMA, DSSUBGRUPOIMP,
    P_NRORG, P_NRORG, P_NRORG,
    P_CDOPERADOR, P_CDOPERADOR,
    SYSDATE, SYSDATE, 'S'
     FROM CICLOSUBGRUSEMAM
    WHERE CDFILIAL = P_CDFILIAL
     AND CDCIA = P_CDCIA
     AND CDMANCIA = P_CDMANCIA
     AND NRSERVICOCIAFILI = P_NRSERVICOCIAFILI
     AND CDCLASSE = P_CDCLASSE
     AND CDSUBGRU = P_CDSUBGRU
     AND NRSEQSUBGRUSEMAM = P_NRSEQSUBGRUSEMAM;
  
  INSERT INTO AUXMONTASUBSEMAM 
   (CDFILIAL, CDCIA, CDMANCIA, 
    NRSERVICOCIAFILI, CDCLASSE, CDSUBGRU, NRSEQSUBGRUSEMAM,
    CDCICLO, DSMONTASUBSEMAM, DSMONTASUBSEMAMHTML, 
    NRORG, NRORGINCLUSAO, NRORGULTATU,
    CDOPERINCLUSAO, CDOPERULTATU,
    DTULTATU, DTINCLUSAO, IDATIVO)
   SELECT CDFILIAL, CDCIA, CDMANCIA, 
    NRSERVICOCIAFILI, CDCLASSE, CDSUBGRU, V_NRSEQSUBGRUSEMAM,
    CDCICLO, DSMONTASUBSEMAM, DSMONTASUBSEMAMHTML, 
    P_NRORG, P_NRORG, P_NRORG,
    P_CDOPERADOR, P_CDOPERADOR,
    SYSDATE, SYSDATE, 'S'
     FROM MONTASUBSEMAM
    WHERE CDFILIAL = P_CDFILIAL
      AND CDCIA = P_CDCIA
      AND CDMANCIA = P_CDMANCIA
      AND NRSERVICOCIAFILI = P_NRSERVICOCIAFILI
      AND CDCLASSE = P_CDCLASSE
      AND CDSUBGRU = P_CDSUBGRU
      AND NRSEQSUBGRUSEMAM = P_NRSEQSUBGRUSEMAM;           

  INSERT INTO AUXPRODSUBSEMAM
   (CDFILIAL, CDCIA, CDMANCIA,
    NRSERVICOCIAFILI, CDCLASSE, 
    CDSUBGRU, NRSEQSUBGRUSEMAM,
    CDPRODUTO, CDCICLO, QTPRODSUMA,
    TXCOPRODSUMA, NRITAIRVISION, NRORDEM,
    QTGRAMATURA, VRPESOGRAMATURA,
    NRORG, NRORGINCLUSAO, NRORGULTATU,
    CDOPERINCLUSAO, CDOPERULTATU,
    DTULTATU, DTINCLUSAO, IDATIVO)
   SELECT CDFILIAL, CDCIA, CDMANCIA,
    NRSERVICOCIAFILI, CDCLASSE, 
    CDSUBGRU, V_NRSEQSUBGRUSEMAM,
    CDPRODUTO, CDCICLO, QTPRODSUMA,
    TXCOPRODSUMA, NRITAIRVISION, NRORDEM,
    QTGRAMATURA, VRPESOGRAMATURA,
    P_NRORG, P_NRORG, P_NRORG,
    P_CDOPERADOR, P_CDOPERADOR,
    SYSDATE, SYSDATE, 'S'
     FROM PRODSUBSEMAM
    WHERE CDFILIAL = P_CDFILIAL
      AND CDCIA = P_CDCIA
      AND CDMANCIA = P_CDMANCIA
      AND NRSERVICOCIAFILI = P_NRSERVICOCIAFILI
      AND CDCLASSE = P_CDCLASSE
      AND CDSUBGRU = P_CDSUBGRU
      AND NRSEQSUBGRUSEMAM = P_NRSEQSUBGRUSEMAM;    
   
  INSERT INTO AUXRECSUBSEMAM
   (CDFILIAL, CDCIA, CDMANCIA, 
    NRSERVICOCIAFILI, CDCLASSE, CDSUBGRU, NRSEQSUBGRUSEMAM,
    CDCICLO, CDRECEITA, QTRECSUMA, TXCOMRECSUMA, NRITAIRVISION, 
    NRORDEM, QTGRAMATURA, VRPESOGRAMATURA, 
    NRORG, NRORGINCLUSAO, NRORGULTATU,
    CDOPERINCLUSAO, CDOPERULTATU,
    DTULTATU, DTINCLUSAO, IDATIVO)
   SELECT CDFILIAL, CDCIA, CDMANCIA, 
    NRSERVICOCIAFILI, CDCLASSE, CDSUBGRU, V_NRSEQSUBGRUSEMAM,
    CDCICLO, CDRECEITA, QTRECSUMA, TXCOMRECSUMA, NRITAIRVISION, 
    NRORDEM, QTGRAMATURA, VRPESOGRAMATURA, 
    P_NRORG, P_NRORG, P_NRORG,
    P_CDOPERADOR, P_CDOPERADOR,
    SYSDATE, SYSDATE, 'S'
     FROM RECSUBSEMAM
    WHERE CDFILIAL = P_CDFILIAL
      AND CDCIA = P_CDCIA
      AND CDMANCIA = P_CDMANCIA
      AND NRSERVICOCIAFILI = P_NRSERVICOCIAFILI
      AND CDCLASSE = P_CDCLASSE
      AND CDSUBGRU = P_CDSUBGRU
      AND NRSEQSUBGRUSEMAM = P_NRSEQSUBGRUSEMAM;  
   
END;
/