var Lib00206_InfComplProduto_Service = function(Lib00206_InfComplProduto_Repository, restEngine) {
    this.getDtprocessa = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return restEngine.post("peblib#/crud/paramestoque_processamento", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.getParamFilial = function(cdFiliMovi){
        var filial = cdFiliMovi || "FILIAL_LOGADA";
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];
        return restEngine.post("peblib#/crud/paramfilial", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.getInfoLote = function(cdFiliMovi,cdProdMovi,nrLoteEstoq,nrSubLote){
        return this.getDtprocessa();
    };

    this.saveLote = function(row){
        row.NRLOTEESTQ = row.NRLOTEESTQ || ' ';
        row.NRSUBLOTE  = row.NRSUBLOTE  || ' ';
        row.DTVALILOTE = row.DTVALILOTE || null;
        row.DTFABRPROD = row.DTFABRPROD || null;

        var saveRow = {
            CDFILIMOVI:row.CDFILIMOVI,
            NRLOTEESTQ:row.NRLOTEESTQ,
            NRSUBLOTE:row.NRSUBLOTE,
            CDPRODESTO:row.CDPRODESTO,
            DTVALILOTE:row.DTVALILOTE,
            DTFABRPROD:row.DTFABRPROD,
            VRFATOCONV: row.VRFATOCONV
        };

        return Lib00206_InfComplProduto_Repository.saveLote(saveRow);
    };

    this.getProdFili = function(cdproduto,cdfilial){
        var filter = [{
            'name':"CDPRODUTO",
            "operator":"=",
            "value":cdproduto
        },
        {
            'name':"CDFILIAL",
            "operator":"=",
            "value":cdfilial
        }];
        return Lib00206_InfComplProduto_Repository.getProdFili(filter);
    };

    this.getProximoLote = function(cdFilial,cdProdesto){
        var filter = [
            {
                "name":"CDFILIAL",
                "operator":"=",
                "value":cdFilial
            },
            {
                "name":"DTVALILTE",
                "operator":"=",
                "value":moment().format('DD/MM/YYYY')
            },
            {
                "name":"CDPRODUTO",
                "operator":"=",
                "value":cdProdesto
            }
        ];
        return Lib00206_InfComplProduto_Repository.getProximoLote(filter);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Lib00206_InfComplProduto_Service', Lib00206_InfComplProduto_Service);
});